#puzzlegame
#rosettacode
#commodorebasic
#
#introandlevel
    10 GOSUB 340
#setupboard
    20 GOSUB 420
#printpuzzle
    30 GOSUB 180
    40 PRINT "\
TO MOVE A PIECE,ENTER ITS NUMBER"
    50 INPUT X
#checkifmoveisvalid
    60 GOSUB 620
    65 IF MV THEN GOTO 100
    70 PRINT "WRONG MOVE"
    80 GOSUB 940
    90 GOTO 30
   100 LET D(Z)=X
   110 LET D(Y)=0
115 PRINT AT 16,0;"Y=";Y;" Z+";Z;" X=";X
#printpuzzle
   120 GOSUB 180
#checkifpuzzlecomplete
   130 GOSUB 870
   140 IF PC THEN GOTO 160
   150 GOTO 40
   160 PRINT"YOU WON"
   170 STOP
#printdrawthepuzzle
   180 FOR P=1 TO 16
   190 IF D(P)=0 THEN LET D$(P)="  "
   200 IF D(P)=0 THEN GOTO 220
   210 LET D$(P)=" "+(" " AND D(P)<10)+STR$ D(P)+"   "
   220 NEXT P
   240 PRINT AT 1,0;"\
+-----+-----+-----+-----+","\
+";D$(1);"+";D$(2);"+";D$(3);"+";D$(4);"+","\
+-----+-----+-----+-----+","\
+";D$(5);"+";D$(6);"+";D$(7);"+";D$(8);"+","\
+-----+-----+-----+-----+","\
+";D$(9);"+";D$(10);"+";D$(11);"+";D$(12);"+","\
+-----+-----+-----+-----+","\
+";D$(13);"+";D$(14);"+";D$(15);"+";D$(16);"+","\
+-----+-----+-----+-----+"
   330 RETURN 
#introandlevelofdifficulty
   340 DIM S(3)
   350 LET S(1)=10
   360 LET S(2)=50
   370 LET S(3)=100
   380 PRINT "\
 15 PUZZLE GAME  FOR ZX81 BASIC ",,,,"\
   ENTER LEVEL OF DIFFICULTY    \
 1(EASY), 2(MEDIUM) OR 3(HARD)  "
   390 INPUT V
   400 IF V<1 OR V>3 THEN GOTO 390
   410 RETURN 
#buildtheboard
   420 PRINT "\
        SHUFFLING PIECES"
   430 DIM D(16)
   440 FAST
#boardpieces
   450 DIM D$(16,5)
#setpiecesincorrectorder
   460 FOR P=1 TO 15
   470 LET D(P)=P
   480 NEXT P
#=emptypieceemptypieceslot
   490 LET D(16)=0
#z=emptyposition
   500 LET Z=16
   510 FOR N=1 TO S(V)
   530 LET X=INT (RND*4)+1
   540 LET R=Z+(X=1)*4-(X=2)*4+(X=3)-(X=4)
   550 IF R<1 OR R>16 THEN GOTO 530
   560 LET D(Z)=D(R)
   570 LET Z=R
   580 LET D(Z)=0
   590 NEXT N
   595 CLS
   600 SLOW 
   610 RETURN 
#checkifmoveisvalid
   620 LET MV=0
   630 IF X<1 OR X>15 THEN RETURN
#findpositionofpiecex
   640 LET P=1
   650 IF D(P)=X THEN LET Y=P
   660 IF D(P)=X THEN GOTO 710
   670 LET P=P+1
   680 IF P>16 THEN PRINT "UH OH"
   690 IF P>16 THEN STOP 
   700 GOTO 650
#findpositionofemptypiece
   710 LET P=1
   720 IF D(P)=0 THEN LET Z=P
   730 IF D(P)=0 THEN GOTO 790
   740 LET P=P+1
   750 IF P>16 THEN PRINT "UH OH"
   760 IF P>16 THEN STOP 
   770 GOTO 720
#checkifemptypieceisabove
#belowleftorrighttopiecex
   790 IF Y-4=Z THEN LET MV=1
   800 IF Y-4=Z THEN RETURN 
   810 IF Y+4=Z THEN LET MV=1
   820 IF Y+4=Z THEN RETURN 
   830 IF Y-1=Z THEN LET MV=1
   840 IF Y-1=Z THEN RETURN 
   850 IF Y+1=Z THEN LET MV=1
   860 RETURN 
#checkifpuzzleiscomplete
#gameover
   870 LET PC=0
   880 LET P=1
   890 IF D(P)<>P THEN RETURN 
   900 LET P=P+1
   910 IF P<16 THEN GOTO 890
   920 LET PC=1
   930 RETURN 
   940 FOR T=0 TO 400
   950 NEXT T
   960 RETURN 
